     subroutine th_22indexRELAXsad(isubthe,icase,iput,iget,info) 
!    sad= source,absorber,detector : lstr1case=1,2,3 (comthe.for)      
     use glbconst, only: maxfr1,maxfr2,maxthss,maxscrd,icstrf,ivstrf,   &
                         enwr,nwr
     use comthe, only: array_fr,theoryname,mLG,ifrcase,lstr1case
     implicit none 
     integer, intent(inout):: isubthe   
     integer, intent(in)   :: icase,iput,iget
     integer, intent(out)  :: info      
                                                                       
      integer,parameter::istr=38+4*(maxfr1+maxfr2)+3*maxthss 
      integer       dstr,iposLG,iadd                                          
      common/struct/dstr(istr+1),iposLG,iadd(6)

      integer       ibe,jpolsource,jpolabsorber,iflag_basis,idum,    &
                    nLG,nAS,nSC,idum2,ak8,sk8,ien
      real          srw8 
      common/strLOC/jpolsource,jpolabsorber,ibe(10),iflag_basis,     &
                    idum,nLG,nAS,nSC,idum2,ak8,sk8,srw8,ien(11)      

     logical       b_vsp,b_v_max,b_dumvsp 
     common/bvstrf/b_vsp(4),b_v_max,b_dumvsp(ivstrf-5) 
                                                                       
!    storage use nst2_8 for 4 complex numbers of r_ik                  
     real          c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,offset,dumc 
     common/acmaps/c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,offset,dumc(icstrf-6) 
     real          avm,sftr,aisom,w_Gauss,wLorentz,dumv 
     logical       b_vm,b_sftr,b_isom,b_w_Gauss,b_wLorentz,b_dumv 
     common/avmaps/avm,sftr,aisom,w_Gauss,wLorentz(8),dumv(ivstrf-12) 
     common/bvmaps/b_vm,b_sftr,b_isom,b_w_Gauss,b_wLorentz(8),           &
                   b_dumv(ivstrf-12)                                    
                                                                       
                                                                       
     logical   b_pc,b_polisp,bxx 
     integer   nE,iflag_SAMP,iflag_Voigt,ioffset,jge,jn,ip,      &
               i,n,ni,nn,nget,nall,n_all,nst      
     real      Eagd,hr,hi,hti,w_Lorentz,gamma,       &
               azz,aszz,fd,srw,fs,sl_t,sl_s
                 
     complex   hrtr,hrpm,ctr,cpm,cmp,hc,hci,trcp,ofcp

     real,    dimension(:), allocatable :: sTr,tint 
     complex, dimension(:), allocatable :: trint,ofint
     complex, dimension(:), allocatable :: cLG

      if(isubthe.lt.0) then 
       theoryname='2x2_ref_index_dynamic_sad    v=101' 
       if(ifrcase.le.4) then 
        i=2 
        if(jpolsource.eq.1) i=4 
        if(-isubthe.eq.1) then 
         c1=i*(nSC+1)+1 
        end if 
        if(-isubthe.eq.2) then 
         c1=2*(nAS+1) 
         if(jpolabsorber.eq.1)c1=c1*4 
        end if 
        if(-isubthe.eq.3) c1=i*(nSC+1) 
       end if 

       if(ifrcase.eq.6) then 
        i=2 
        if(-isubthe.eq.2) then 
         c1=2*(nAS+1) 
         if(jpolabsorber.eq.1)c1=c1*4 
        end if 
        if(-isubthe.eq.3) c1=i*(nSC+1) 
       end if 

       if(ifrcase.eq.5) then 
        c1=2*(nAS+1) 
        if(jpolabsorber.eq.1) c1=c1*4 
       end if
       return 
      end if 
!       write(6,'(a,6f10.2)')'th_22refindexf avm,sftr,aisom,w_Gauss,w_Lorentz=',& 
!                      avm,sftr,aisom,w_Gauss,w_Lorentz               
                                                                        
      hci=cmplx(0.,1.) 
      iflag_SAMP=flag_SAMP 
      iflag_Voigt=flag_Voigt 
      nst=4 
                                                                        
      call get_theory(isubthe,info) 
      if(info.gt.0) return 
!       write(6,'(a,5f10.4,/,50x,5l5)')                                 
!     &  'th_22refindexf avm,sftr,aisom,w_Gauss,w_Lorentz=',            
!     &                  avm,sftr,aisom,w_Gauss,w_Lorentz,              
!     &             b_vm,b_sftr,b_isom,b_w_Gauss,b_w_Lorentz            
                                                                        
      b_pc=b_v_max.or.b_isom.or.b_w_Gauss.or.isubthe.gt.0 
      do i=1,8
       b_pc=b_pc.or.b_wLorentz(i)
      end do
      if(.not.b_pc.or.info.gt.0) then 
       isubthe=-abs(isubthe) 
       goto 400 
      else 
        isubthe=abs(isubthe) 
      end if 
                                                                        
      nget=real(array_fr(iget+1))+2
      n_all=real(array_fr(nget-1)) 
      jge=aimag(array_fr(nget-1)) 
      bxx=real(array_fr(nget)).gt.0.01 
                                                                        
      ioffset=offset 
!      write(6,'(a,5i8)')&
!      '  2x2_ref_index_static_f iget,nget,iput,lstr1case,ioffset=', &    
!              iget,nget,iput,lstr1case,ioffset                           
                                                                        
      goto (100,200,300),lstr1case 
!---------------------- source ------------------------------------     
  100 continue 
!      write(6,'(a,L5)') 'jpolsource=',jpolsource 
      ioffset=offset
      b_polisp=jpolsource.eq.1
      fs=0.
      do nall=1,n_all 
       ip=nget+(3*jge+2)*(nall-1) 
                                                                        
       if(enwr(7).eq.'fani') then 
        aszz=aimag(array_fr(ip+1)) 
        azz =aimag(array_fr(ip+1)) 
        fd=exp(-azz-aszz) 
        fs=fs+fd 
        write(nwr,'(a,i2,a2,f10.3)')                                    &
          'anisotropic part of the f-source(',nall,')=',fd             
       end if 
                                                                        
       do jn=ip+3,ip+3+jge*3,3 
        Eagd=real(array_fr(jn))+aisom 
        nE=ifix(Eagd/srw8+0.5)          ! nE <= sk8   
        if (abs(nE).gt.sk8) write(nwr,'(2(a,f10.2),a)')                 &
         '**** E(source)=',Eagd,' out of range ',sk8*srw8,'[mm/s]'     
       end do   ! jn=   
      end do   ! nall=1,n_all 
      if(enwr(7).eq.'fani') write(nwr,'(a,f10.3)')                      &
       'average over all sites and directions of f-source=',fs/n_all   
                                                                        
       i=2 
       if(b_polisp) i=4 
       do n=iput+1,iput+(nSC+1)*i 
        array_fr(n)=(0.,0.) 
       end do 
       w_Lorentz=wLorentz(1) 

                                                                        
       allocate(cLG(-nSC:nSC))
       srw=4.0*srw8 
                                                                        
       do nall=1,n_all 
        ip=nget+(2+3*jge)*(nall-1) 

        aszz=aimag(array_fr(ip+1)) 
        azz =aimag(array_fr(ip+1)) 
        fd=exp(-azz-aszz) 
        ! array_fr(ip+2) not used =(0,0)

        do jn=ip+2,ip+2+jge*3-3,3 
         Eagd=real(array_fr(jn+1))+aisom
         gamma=aimag(array_fr(jn+1))+gamnat
         call aLORGAU(Eagd,gamma,e_xsi,   &
                       srw,w_Lorentz,w_Gauss,iflag_Voigt,nSC,cLG)     

         if (iflag_basis.eq.1) then
          hrtr=array_fr(jn+2)*fd 
          hrpm=array_fr(jn+3)*fd 
         else
          hrtr=cmplx(-real(array_fr(jn+3)),aimag(array_fr(jn+2)))*fd 
          hrpm=cmplx(-aimag(array_fr(jn+3)),real(array_fr(jn+2)))*fd 
         end if
                                                                      
         hti= aimag(hrtr)/2.0 
         ctr= real(hrtr)*hci/2.0 
         cpm= hrpm*hci/2.0 
         cmp= conjg(hrpm)*hci/2.0 
!        nE=ifix(Eagd/srw8+0.5)                                        
!        if(abs(Eagd).gt.4.9) then  
!         write(6,'(i8,a,8f10.2)')ige,' Esource=',Eagd,hrtr*100,hrpm*100 
                                                                      
         if(b_polisp) then 
          do n=0,nSC 
           nn=iput+4*n 
           array_fr(nn+1)=array_fr(nn+1)+ aimag(cLG(n ))*hrtr 
           array_fr(nn+2)=array_fr(nn+2)+ aimag(cLG(n ))*hrpm 
           array_fr(nn+3)=array_fr(nn+3)+ aimag(cLG(-n))*hrtr 
           array_fr(nn+4)=array_fr(nn+4)+ aimag(cLG(-n))*hrpm 
          end do 
         else 
          do n=0,nSC 
           nn=iput+2*n 
           array_fr(nn+1)=array_fr(nn+1)+ aimag(cLG(n ))*hrtr 
           array_fr(nn+2)=array_fr(nn+2)+ aimag(cLG(-n))*hrtr 
          end do 
         end if
        end do       ! jn=
       end do         ! n_all
      deallocate(cLG)
                                                                        
!     The sum of the Lorentz-Gauss curves of the jge lines              
!     have to be normalized to 1 for each subspectrum of the source     
!     iscpi=iscpr+2*nSC+1                                               
                                                                        
!     write(6,'(a,i5,5x,2f15.8)')                                       
!    &           ' isc3,sTr(0)=',isc3,array_fr(isc3+1)  
        allocate(sTr(-nSC:nSC))
                
        if(b_polisp) then 
         do i=0,nSC 
          nn=iput+4*i 
          sTr(i)=aimag(array_fr(nn+1)) 
          sTr(-i)=aimag(array_fr(nn+3)) 
         end do 
        else 
         do i=0,nSC 
          nn=iput+2*i 
          sTr(i)=aimag(array_fr(nn+1)) 
          sTr(-i)=aimag(array_fr(nn+2)) 
         end do 
        end if 
!         write(6,'(a,i4,a,2f15.5)') (' i=',i,'sTr(+-i)=',              
!     &    sTr(i),sTr(-i),i=0,5)                                        
                                                                        
         hr=0. 
         do n=-nSC+1,nSC-1,2 
          hr=hr+ sTr(n)*2 
         end do 
         do n=-nSC+2,nSC-2,2 
          hr=hr+sTr(n) 
         end do 
         hr=hr*2.+ sTr(-nSC)+sTr(nSC); hr=hr/3. 

        if(b_polisp) then 
         do i=0,nSC 
          nn=iput+4*i 
          array_fr(nn+1)=cmplx(real(array_fr(nn+1)),sTr(i))/hr 
          array_fr(nn+2)=array_fr(nn+2)/hr
          array_fr(nn+3)=cmplx(real(array_fr(nn+3)),sTr(-i))/hr 
          array_fr(nn+4)=array_fr(nn+4)/hr      
         end do 
        else 
         do i=0,nSC 
          nn=iput+2*i 
          array_fr(nn+1)=cmplx(real(array_fr(nn+1)),sTr(i))/hr 
          array_fr(nn+2)=cmplx(real(array_fr(nn+2)),sTr(-i))/hr  
         end do 
        end if 

        if(enwr(7)(1:2).eq.'sl'.and.sl_t.gt.0.) hr=hr*sl_t/sl_s
        deallocate(sTr)
       goto 400 
!------------------------ absorber ----------------------------------   
  200  continue 
!    write(6,'(a,5i6)') '2x2_ref n_all,icase,iflag_SAMP=',n_all,icase,iflag_SAMP                     
!    write(6,'(a,L5)') 'jpolabsorber=',jpolabsorber

     b_polisp=jpolabsorber.eq.1    
     fs=0. 
     do nall=1,n_all 
      ip=nget+(2+3*jge)*(nall-1) 
                                                                       
      if(enwr(7).eq.'fani') then 
       aszz=aimag(array_fr(ip+1)) 
       azz =aimag(array_fr(ip+1)) 
       fd=exp(-azz-aszz) 
       fs=fs+fd 
       write(nwr,'(a,i2,a2,f10.3)')                                    &
         'anisotropic part of the f-source(',nall,')=',fd             
      end if 

      do jn=ip+3,ip+3+jge*3,3 
       Eagd=real(array_fr(jn))+aisom 
       nE=ifix(Eagd/srw8+0.5)          ! nE <= sk8 
      if (abs(nE).gt.ak8) write(nwr,'(2(a,f10.4),a)')                 &
       '**** E(absorber)=',Eagd,' out of range ',ak8*srw8,'[mm/s]'   
      end do  ! jn=  
     end do   !  nall=1,n_all  
     if(enwr(7).eq.'fani') write(nwr,'(a,f10.3)')                     &
     'average over all sites and directions of f-absorber=',fs/n_all 
                                                                      
      i=2 
      if(jpolabsorber.eq.1) i=8 
      do n=iput+1,iput+(nAS+1)*i 
       array_fr(n)=(0.,0.) 
      end do 

     w_Lorentz=wLorentz(1) 

     allocate(cLG(-nAS:nAS))

     srw=srw8*float(nst) 
     hi=0.0; hr=0.0 
     trcp=(0.,0.)
     ofcp=(0.,0.)
     allocate(tint(jge),trint(jge),ofint(jge))
!    shrtr=(0.,0.)     
    do nall=1,n_all 
      ip=nget+(2+3*jge)*(nall-1) 
                                                                      
      aszz=aimag(array_fr(ip+1)) 
      azz =aimag(array_fr(ip+1)) 
      fd=exp(-azz-aszz) 

      do jn=ip+2,ip+2+jge*3-3,3 
       Eagd=real(array_fr(jn+1))+aisom
       gamma=gamnat-aimag(array_fr(jn+1))
       w_Lorentz=gamma/gamnat-1.
!      normalization of cLG(w_Lorentz*gamnat)

       call aLORGAU(Eagd,gamnat,e_xsi,          &
                    srw,w_Lorentz,w_Gauss,iflag_Voigt,nAS,cLG)     
       if (iflag_basis.eq.1) then
        hrtr=array_fr(jn+2)*fd 
        hrpm=array_fr(jn+3)*fd 
       else
        hrtr=cmplx(-real(array_fr(jn+3)),aimag(array_fr(jn+2)))*fd 
        hrpm=cmplx(-aimag(array_fr(jn+3)),real(array_fr(jn+2)))*fd 
       end if
                                                                     
       hti= aimag(hrtr)/2.0 
       ctr= real(hrtr)*hci/2.0 
       cpm= hrpm*hci/2.0 
       cmp= conjg(hrpm)*hci/2.0
!      shrtr=shrtr+hrtr 
!       write(6,'(a,8f10.3)')'w_Lorentz,Eagd,hrtr=',w_Lorentz,Eagd,hrtr
!       write(6,'(2a,/,5f10.4,5i8)')'gamnat,e_xsi,',                  
!   &   'srw8,w_Lorentz,w_Gauss,nLG,iflag_Voigt,iposLG=',        
!   &    gamnat,e_xsi,srw*250,w_Lorentz,w_Gauss,nAS,iflag_Voigt       
                                                          
       if(b_polisp) then 
        do n=0,nAS 
         ni=iput+8*n 
         hc=cLG(n) 
         array_fr(ni+1)=array_fr(ni+1)-hc*hti 
         array_fr(ni+2)=array_fr(ni+2)-hc*ctr 
         array_fr(ni+3)=array_fr(ni+3)-hc*cpm 
         array_fr(ni+4)=array_fr(ni+4)-hc*cmp 
         hc=cLG(-n) 
         array_fr(ni+5)=array_fr(ni+5)-hc*hti 
         array_fr(ni+6)=array_fr(ni+6)-hc*ctr 
         array_fr(ni+7)=array_fr(ni+7)-hc*cpm 
         array_fr(ni+8)=array_fr(ni+8)-hc*cmp 
        end do 
       else 
        do n=0,nAS 
         ni=iput+2*n 
         hc=conjg(cLG(n)) 
         array_fr(ni+1)=array_fr(ni+1)-hc*hti 
         hc=conjg(cLG(-n)) 
         array_fr(ni+2)=array_fr(ni+2)-hc*hti 
        end do 
       end if 
      end do       !   jn=
     end do        ! nall=1,n_all
!    write(6,'(a,8f10.3)')'shrtr=',shrtr 
    deallocate(cLG)
    goto 400 
                                                                      
!------------------------------detector-----------------------------------   
  300  continue 
   print'(a)',' only scalar theories are expected' 
                                                                        
  400 return 
      END                                           
