  program channel_sum

      implicit none 
      integer i,il,j,k,npl,nrd,nwr,nini                            

      character*132 chcom,filename,ch132,co132,filetype*32,exten*16   
      logical b_file 
       real  channel(1024),sum

      nini=7 
      npl=80 
      nrd=5 
      nwr=6 

      filename='pulsheightspectrum.dat' 
      il=18
      chcom='what do do' 
      filetype='counts/channel' 
      exten='dat' 
                                                                        
   10 call readfile(filetype,filename,exten,il,chcom,npl,nrd,nwr)
       inquire(file=filename,exist=b_file) 
       if(b_file) then 
        open(unit=nini,file=filename                                    &
     &            ,status='old'                                         &
     &            ,access='sequential'                                  &
     &            ,form='formatted')                                    
       else 
        goto 10 
       end if 

       read(nini,'(a)') ch132 
        print*,ch132
!       read(nini,'(a)') ch132 
!        print*,ch132
!       read(nini,'(a)') ch132 
!        print*,ch132

       sum=0.0 
       do k=1,1024
        read(nini,*)channel(k)
!        print*,channel(k)
        sum=sum+channel(k)
       end do
     
       print '(a,f15.0)', 'sum over all channels:',sum 

 stop
 end


      subroutine readfile(filetype,deffile,exten,ld,chcom,ncol,nrd,nwr) 
      character*132 ch132,chblank,deffile,exten*16,chcom,filetype*32 
                                                                        
       chblank=' ' 
       ch132=filetype 
       lf=ncol 
       call stringlength(ch132,lf) 
       ch132=exten 
       le=ncol 
       call stringlength(ch132,le) 
       ld=ncol 
       call stringlength(deffile,ld) 
       nf=ncol-(27+lf) 
    2  if(ld.lt.nf) then 
         write(nwr,'(4a,a1)') '/directory/',filetype(1:lf),             &
     &                              '_file.exten:  [',deffile(1:ld),']' 
       else 
         write(nwr,'(3a,/,a1,a,a1)')'/directory/',filetype(1:lf),       &
     &    '_file.exten:','[',deffile(1:ld),']'                          
       end if 
                                                                        
       read(nrd,'(a)') ch132 
       write(nwr,'(1x,a1,a3)') char(27),'[2A' 
!       call lc_character(ch132) 
       if(ch132(1:2).eq.'he') then 
        call help(chcom) 
        goto 2 
       end if 
       if(ch132(1:1).eq.'*'.or.ch132(1:1).eq.'q') then 
        ld=0 
        return 
       end if 
       if(ch132.ne.' ') then 
        deffile=ch132 
        ldl=ld 
        call nextchar(deffile,0,ipos,ch132,ld) 
        deffile=ch132 
        i=index(deffile,'.') 
        if(i.eq.0) then 
         deffile=deffile(:ld)//'.'//exten(1:le) 
         ld=ld+le+1 
        else 
         i=132 
         ii=0 
         do while(ii.eq.0.and.i.gt.0) 
          if(deffile(i:i).eq.'.') ii=i 
          i=i-1 
         end do 
         exten=deffile(ii+1:) 
        end if 
        if(ldl.gt.nf) write(nwr,'(1x,a1,a3)') char(27),'[2A' 
        write(nwr,'(1x,a1,a3)') char(27),'[2A' 
        write(nwr,'(a,/,a)') chblank(:ncol),chblank(:ncol) 
        if(ldl.gt.nf) then 
        write(nwr,'(a,/,a)') chblank(:ncol),chblank(:ncol) 
        write(nwr,'(1x,a1,a3)') char(27),'[3A' 
        end if 
        write(nwr,'(1x,a1,a3)') char(27),'[3A' 
        goto 2 
       end if 
       return 
      END                                           
                                                                        
                                                                        
      subroutine yesno(querytype,ch1,chcom,ncol,nrd,nwr) 
      character*132 ch132,querytype,chcom,ch1*1,wrb*1 
                                                                        
       wrb=querytype(132:132) 
       querytype(132:132)=' ' 
       ld=ncol 
       call stringend(querytype,ld) 
       if(wrb.eq.'r') then 
        read(10,'(a)') ch132 
        write(nwr,'(a)') ch132 
        i=index(ch132,'[')+1 
        ch1=ch132(i:i) 
        return 
       end if 
   10  write(nwr,'(a,a2,2a1)') querytype(1:ld),' [',ch1,']' 
       read(nrd,'(a)') ch132 
       write(nwr,'(1x,a1,a3)') char(27),'[2A' 
       call lc_character(ch132) 
       if(ch132(1:2).eq.'he') then 
        call help(chcom) 
        goto 10 
       end if 
       if(ch132(1:1).eq.' ') then 
        if(wrb.eq.'w')                                                  &
     &  write(10,'(a,a2,2a1)') querytype(1:ld),' [',ch1,']'             
        return 
       end if 
       if(ch132(1:1).eq.'*'.or.ch132(1:1).eq.'q') then 
        ch1='*' 
        return 
       end if 
       if(ch132(1:1).eq.'n') ch1='n' 
       if(ch132(1:1).eq.'y') ch1='y' 
        ch132=' ' 
        write(nwr,'(1x,a1,a3)') char(27),'[2A' 
        write(nwr,'(a,/,a)') ch132(:ncol),ch132(:ncol) 
        write(nwr,'(1x,a1,a3)') char(27),'[3A' 
       goto 10 
      END                                           
                                                                        
      subroutine askstring(querytype,chstr,chcom,ncol,nwr) 
      character*132 ch132,cp132,chstr,querytype,chcom,wrb*1 
                                                                        
       wrb=querytype(132:132) 
       querytype(132:132)=' ' 
                                                                        
       ld=ncol 
       ch132=querytype 
       call stringend(ch132,ld) 
       call stringlength(chstr,ls) 
       if(wrb.eq.'r') then 
        read(10,'(a)') ch132 
        i=index(ch132,'[')+1 
        chstr=ch132(i:i+ls-1) 
        return 
       end if 
   10  write(nwr,'(a,a2,a,a1)')querytype(1:ld),' [',chstr(1:ls),']' 
       ch132='xxxxxxx' 
       read(nrd,'(a)') ch132 
       write(nwr,'(1x,a1,a3)') char(27),'[2A' 
       cp132=ch132 
       call lc_character(cp132) 
       if(cp132(1:2).eq.'he') then 
        call help(chcom) 
        goto 10 
       end if 
!       write(6,'(a)') 'combuff ch132=',ch132(1:4)//'ende 1-4'          
       if(ch132(1:1).eq.' '.or.ch132(1:1).eq.'*') then 
        if(wrb.eq.'w') write(10,'(a,a2,a,a1)')                          &
     &     querytype(1:ld),' [',chstr(1:ls),']'                         
        return 
       end if 
        chstr=ch132 
        call stringlength(chstr,ls) 
        cp132=' ' 
        write(nwr,'(1x,a1,a3)') char(27),'[2A' 
        write(nwr,'(a,/,a)') cp132(:ncol),cp132(:ncol) 
        write(nwr,'(1x,a1,a3)') char(27),'[3A' 
       goto 10 
      END                                           
                                                                        
      subroutine stringend(ch,il) 
      character*132 ch 
      if(ch.eq.' ') then 
       il=0 
       return 
      end if 
      do while(ch(il:il).eq.' ') 
       il=il-1 
      end do 
      return 
      END                                           
                                                                        
                                                                        
       subroutine chcenter(ch,ch1,ncol) 
       character*132 ch,ch1*1 
        call stringlength(ch,l) 
        i=(ncol-l)/2 
        do k=l,1,-1 
         ch(i+k:i+k)=ch(k:k) 
        end do 
        do k=1,i 
         ch(k:k)=ch1 
        end do 
        k=i+l+1 
        do while(k.le.ncol) 
         ch(k:k)=ch1 
         k=k+1 
        end do 
        return 
      END                                           
                                                                        
      subroutine lc_character(ch) 
      character*132 ch 
       call stringlength(ch,l) 
       do i=1,l 
        in=ichar(ch(i:i)) 
        if(in.lt.91.and.in.gt.64) in=in+32 
        ch(i:i)=char(in) 
       end do 
      return 
      END                                           
                                                                        
       subroutine nextchar(chl,il,ip,cha,ia) 
       character*132 chl,cha 
       integer il,ip,ia 
                                                                        
       do k=132,il+1,-1 
        if(chl(k:k).ne.' ') goto 5 
       end do 
    5  npl=k+1 
!       write(6,'(2i4,2a)') il,npl,' nextchar chl=',chl(1:20)           
                                                                        
       cha=' ' 
       if(il.gt.0) then 
        do k=il+1,npl 
          if(chl(k:k).eq.' '.or.chl(k:k).eq.',') then 
          i=k 
          goto 10 
          end if 
        end do 
   10   continue 
       else 
         i=1 
       end if 
!       write(6,'(3i3,2a)') il,npl,i,' nextchar chl=',chl(1:20)         
                                                                        
       j=npl 
       do k=i,npl 
        if(chl(k:k).ne.' '.and.chl(k:k).ne.',') then 
         j=k 
         goto 20 
        end if 
       end do 
   20  continue 
       ip=k 
                                                                        
       do k=j,npl 
        kj=k-j+1 
        cha(kj:kj)=chl(k:k) 
       end do 
!    the first character is stripped, cha starts with the second symbol 
!       write(6,'(i3,2a)') j,' nextchar cha=',cha(1:20)                 
       ia=npl-1 
       do k=1,npl 
        if(cha(k:k).eq.' '.or.cha(k:k).eq.',') then 
         ia=k-1 
         goto 30 
        end if 
       end do 
   30  return 
      END                                           
                                                                        
      subroutine stringlength(ch,il) 
      character*132 ch 
      if(ch.eq.' ') then 
       il=0 
       return 
      end if 
      do k=1,132 
       if(ch(k:k).ne.' ') goto 10 
      end do 
   10 do j=132,k,-1 
       if(ch(j:j).ne.' ') goto 20 
      end do 
   20 continue 
      il=j-k+1 
      j=k-1 
                                                                        
      do i=1,il 
       ch(i:i)=ch(j+i:j+i) 
      end do 
      ch(il+1:il+k)=' ' 
      return 
      END                                           
                                                                        
      subroutine help(chcom) 
      character*132 chcom 
      write(nwr,'(a)') 'no help available' 
      return 
      END                                           
